package fetchKeywords;




import fetchOpinionWords.SWN3;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import javax.swing.text.html.HTMLDocument.Iterator;

import opennlp.tools.lang.english.PosTagger;
import opennlp.tools.ngram.Dictionary;

import org.apache.lucene.index.Term;
import org.apache.uima.UimaContext;
import org.apache.uima.analysis_component.JCasAnnotator_ImplBase;
import org.apache.uima.analysis_engine.AnalysisEngineProcessException;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.examples.opennlp.Sentence;
import org.apache.uima.examples.opennlp.Token;
import org.apache.uima.jcas.JCas;
import org.apache.uima.jcas.JCasRegistry;
import org.apache.uima.jcas.cas.TOP_Type;

import org.apache.uima.jcas.tcas.Annotation;


import org.apache.uima.resource.ResourceInitializationException;

import annotationType.KeywordsByDocFreq;


public class KeywordsByDF extends JCasAnnotator_ImplBase {

 
     
  //public static final String MODEL_FILE_PARAM = "ModelFile";
  public TextFileIndexer index=new TextFileIndexer();
  
 // private PosTagger tagger;

  /**
   * Initialize the Annotator.
   * 
   * @see JCasAnnotator_ImplBase#initialize(UimaContext)
   */
  public void initialize(UimaContext aContext) throws ResourceInitializationException {
    super.initialize(aContext);
   
    
    try {
      // Get configuration parameter values
    	index.buildIndex();
    	System.out.println("INDEX DONE");
  //    String modelFile = (String) aContext.getConfigParameterValue(MODEL_FILE_PARAM);
   //   tagger = new PosTagger(modelFile, (Dictionary) null);
    } catch (Exception e) {
      throw new ResourceInitializationException(e);
    }
  }

  /**
   * Process a CAS.
   * 
   * @see JCasAnnotator_ImplBase#process(JCas)
   */
  public void process(JCas aJCas) throws AnalysisEngineProcessException {
    
    ArrayList<Token> tokenList = new ArrayList<Token>();
    ArrayList wordList = new ArrayList();
    HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();
    ArrayList<Term> docFreq=null;
	try {
		docFreq = index.rankingDocFreq();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
    
  //  HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();

    //int sen=0;
    
    AnnotationIndex sentenceIndex = aJCas.getAnnotationIndex(Sentence.type);
    AnnotationIndex tokenIndex = aJCas.getAnnotationIndex(Token.type);

    // iterate over Sentences
    FSIterator sentenceIterator = sentenceIndex.iterator();
    while (sentenceIterator.hasNext()) {
    
     //  System.out.println("-------SENTENCE--------");
       	
   
      Sentence sentence = (Sentence) sentenceIterator.next();

  //    tokenList.clear();
    //  wordList.clear();

      // iterate over Tokens
      FSIterator tokenIterator = tokenIndex.subiterator(sentence);
     
      while (tokenIterator.hasNext()) {
       
    	Token token = (Token) tokenIterator.next();
        
    	tokenList.add(token);
        
   
             
				for(int i=0; i<docFreq.size();i++)
                
				{	   
						   if(token.getCoveredText().toLowerCase().equals(docFreq.get(i).text().toLowerCase()))
						   {   
							   
							   KeywordsByDocFreq keywords=new KeywordsByDocFreq(aJCas); 
					           keywords.setBegin(token.getBegin());
					           keywords.setEnd(token.getEnd());
					           keywords.addToIndexes();   
					          // System.out.println("keywords:"+keywords.getCoveredText());
						   }
						   
						   
				}
			} 
			} 
          
        //}
       
     }
   }

