package fetchKeywords;



import fetchOpinionWords.SWN3;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import opennlp.tools.lang.english.PosTagger;
import opennlp.tools.ngram.Dictionary;

import org.apache.uima.UimaContext;
import org.apache.uima.analysis_component.JCasAnnotator_ImplBase;
import org.apache.uima.analysis_engine.AnalysisEngineProcessException;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.examples.opennlp.Sentence;
import org.apache.uima.examples.opennlp.Token;
import org.apache.uima.jcas.JCas;
import org.apache.uima.resource.ResourceInitializationException;

import annotationType.KeywordsByTF;

	
	public class KeywordsByNounPlus extends JCasAnnotator_ImplBase {

	  //public static final String MODEL_FILE_PARAM = "ModelFile";

	 // private PosTagger tagger;
		 public TextFileIndexer index=new TextFileIndexer();
	     public static int i=0;
	     public static File   fileDir  = new File("F:/Master Thesis/input");
	     public static File[] textFiles  = fileDir.listFiles();
	     public ArrayList<String> keywordsTotal=new ArrayList<String>();
	     public static long  startTime;
	    // long endTime;
	     public HashMap<String, Integer> keywordsMap=new HashMap<String, Integer>();
	     
		 static HashMap<String,Vector<String>> keywordsFile=new HashMap<String,Vector<String>>();
		 static HashMap<String,Vector<String>> filesByYear=new HashMap<String,Vector<String>>();
		 static HashMap<String,Vector<String>> keywordsByYear=new HashMap<String,Vector<String>>();
		 
		 
		 public static ArrayList<String> commonTopics=new ArrayList<String>(); 
		 public static String year;
		 public static String type;
		 
		 
		 /**
	   * Initialize the Annotator.
	   * 
	   * @see JCasAnnotator_ImplBase#initialize(UimaContext)
	   */
	  public void initialize(UimaContext aContext) throws ResourceInitializationException {
	    super.initialize(aContext);

	    try {
	    	startTime = new Date().getTime();
	    	index.buildIndex();
	    	System.out.println("INDEX DONE");
	      // Get configuration parameter values
	  //    String modelFile = (String) aContext.getConfigParameterValue(MODEL_FILE_PARAM);
	   //   tagger = new PosTagger(modelFile, (Dictionary) null);
	    } catch (Exception e) {
	      throw new ResourceInitializationException(e);
	    }
	  }

	  /**
	   * Process a CAS.
	   * 
	   * @see JCasAnnotator_ImplBase#process(JCas)
	   */
	  @SuppressWarnings("null")
	public void process(JCas aJCas) throws AnalysisEngineProcessException {
		  
	   if(i<textFiles.length){
		  
		   String name=textFiles[i].getName();
		   
		  
		   
		   String[] string=name.split("-");
		   String yearandtype=string[0];
		   String[] yeartype=yearandtype.split("_");
		   year=yeartype[0];
		   
		   Vector<String> files=new Vector<String>();
		   if(filesByYear.get(year)!=null)
			   files=filesByYear.get(year);
		   
		   files.add(name);  
		   filesByYear.put(year,files);
		   
		   type=yeartype[1];
		   String titlestring=string[3];
		   String[] title=titlestring.split("_");
		   ArrayList<String> titles=new ArrayList<String>();
		   System.out.println(i);
		   for(String w:title){
			  //  System.out.println("TITLE"+w);
	    		if(!w.toLowerCase().equals("a")&&!w.toLowerCase().equals("an")&&!w.toLowerCase().equals("the")
	    				&&!w.toLowerCase().equals("on")&&!w.toLowerCase().equals("in")&&!w.toLowerCase().equals("of")
	    				&&!w.toLowerCase().equals("you")&&!w.toLowerCase().equals("to")&&!w.toLowerCase().equals("do")
	    					&&!w.toLowerCase().equals("and")&&!w.toLowerCase().equals("at")&&!w.toLowerCase().equals("be")
	    						&&!w.toLowerCase().equals("are")&&!w.toLowerCase().equals("but")&&!w.toLowerCase().equals("by")
	    							&&!w.toLowerCase().equals("for")&&!w.toLowerCase().equals("if")&&!w.toLowerCase().equals("into")
	    								&&!w.toLowerCase().equals("is")&&!w.toLowerCase().equals("it")&&!w.toLowerCase().equals("or")
	    								   &&!w.toLowerCase().equals("such")&&!w.toLowerCase().equals("that")&&!w.toLowerCase().equals("their")
	    								   	&&!w.toLowerCase().equals("then")&&!w.toLowerCase().equals("there")&&!w.toLowerCase().equals("these")
	    								   	 	&&!w.toLowerCase().equals("they")&&!w.toLowerCase().equals("this")&&!w.toLowerCase().equals("was")
	    								   	 	 	&&!w.toLowerCase().equals("were")&&!w.toLowerCase().equals("with")&&!w.toLowerCase().equals("will")
	    		
	    		){
	    			titles.add(w);
	    		}
		   }
		
		   
		ArrayList<Token> tokenList = new ArrayList<Token>();
	    ArrayList wordList = new ArrayList();
	    HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();
	    
	    
	    AnnotationIndex sentenceIndex = aJCas.getAnnotationIndex(Sentence.type);
	    AnnotationIndex tokenIndex = aJCas.getAnnotationIndex(Token.type);

	    // iterate over Sentences
	    FSIterator sentenceIterator = sentenceIndex.iterator();
	    while (sentenceIterator.hasNext()) {
	    
	     //  System.out.println("-------SENTENCE--------");
	       	
	   
	      Sentence sentence = (Sentence) sentenceIterator.next();

	  //    tokenList.clear();
	    //  wordList.clear();

	      // iterate over Tokens
	      FSIterator tokenIterator = tokenIndex.subiterator(sentence);
	     
	      while (tokenIterator.hasNext()) {
	       
	    	Token token = (Token) tokenIterator.next();
	        
	    	tokenList.add(token);
	        
	    	String posTag = token.getPosTag();
	    	
	        if(posTag!=null&&posTag.equals("NN")||posTag.equals("NNS")||posTag.equals("NNP")){
	                  
	                if(tokenList1.get(token.getCoveredText()) != null){
	     				tokenList1.put(token.getCoveredText(),tokenList1.get(token.getCoveredText())+1);
	        	    //    System.out.println("keywords"+token.getCoveredText());
	                 }
	                 else{
	                	   tokenList1.put(token.getCoveredText(),1); 
	                 }         
	             }
	        	 
	         }
	           
	        
	      }
	    
	   
	            
	    Object[] value =  tokenList1.values().toArray() ;
	    Arrays.sort(value);
	  //  for(int i=0;i<value.length;i++)
	    //    System.out.println(value[i]);
	    //int i=0;
	  //  System.out.println(tokenList1.keySet());
	    
	    ArrayList<String> potentialkeywords = new ArrayList<String>();
	    
	    for(Object o:tokenList1.keySet()){
	    	
	    	if(value.length-1>=0){
	    	   if(tokenList1.get(o).equals(value[value.length-1])){
	    		  potentialkeywords.add(o.toString());	
	    	   }
	    	}
	    	
	    	
	    	if(value.length-2>=0){
	    	    if(tokenList1.get(o).equals(value[value.length-2])){
	    		     potentialkeywords.add(o.toString());
	    	    }
	    	}
	    	
	    	if(value.length-3>=0){
	    	     if(tokenList1.get(o).equals(value[value.length-3])){
	    		        potentialkeywords.add(o.toString());
	             }
	    	}
	    }
	    
	    
	    ArrayList<String> nounAndTitle = new ArrayList<String>();
		for(String keywords:potentialkeywords){
			try {
				if(index.docFreq(keywords)!=0)
				    nounAndTitle.add(keywords);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	    
	   if(titles!=null){
	      for(String w:titles){
	       // System.out.println("TITLES"+w);
			boolean flag=false;	
			for(String keywords:potentialkeywords){
				//nounAndTitle.add(keywords);
	    		if(keywords.toLowerCase().equals(w.toLowerCase())){		     
			        flag=true;   
	    			break;
		          }
			}
			
	       if(flag==false){
					nounAndTitle.add(w);
		    }
	
	      }
			
	    }
	        
	  
	   if(nounAndTitle!=null){
		   
	   for(String w:nounAndTitle){
		   
		//   System.out.println("nounandTitle "+w);
		  // String key=tokenList.get(i).getCoveredText();
		   
		    Vector<String> vector1=new Vector<String>();
		    if(keywordsByYear.get(year)!=null){
		            vector1=keywordsByYear.get(year);
		    }
		            
		    vector1.add(w);
		    keywordsByYear.put(year, vector1);
		  
		    
		    
		   
		  try {
			//if(index.docFreq(w.toLowerCase())>5){
				  if(keywordsMap.containsKey(w)){
					  keywordsMap.put(w,keywordsMap.get(w)+1);
					  Vector<String> vector=new Vector<String>();
					  vector=keywordsFile.get(w);
					  vector.add(name);
					  keywordsFile.put(w, vector);
					
					 
			      }
			      else{
			          keywordsMap.put(w,1);
			          Vector<String> vector=new Vector<String>();
					  vector.add(name);
					  keywordsFile.put(w, vector);
			      }
				  
			  //}
		} //catch (IOException e1) {
			// TODO Auto-generated catch block
			//e1.printStackTrace();
		//} 
	   catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	    		
		
		
		for(int i=0; i<tokenList.size();i++){
	    			
	    			try {
	    
						if(tokenList.get(i).getCoveredText().toLowerCase().equals(w.toLowerCase())){
				        		     
							    //     System.out.println(tokenList.get(i).getCoveredText());
							         KeywordsByTF keywords1=new KeywordsByTF(aJCas); 
						             keywords1.setBegin(tokenList.get(i).getBegin());
						             keywords1.setEnd(tokenList.get(i).getEnd());
						             keywords1.addToIndexes();  
						            // keywordsTotal.add(tokenList.get(i).getCoveredText());
						          
						}
					    	
				      }
					    		
						  
			//	catch (IOException e) {
						// TODO Auto-generated catch block
				//		e.printStackTrace();
					//} 
	    			catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
	             }//for
	    		  
	    	} //for    
	       
	    } //if
	    i++;
	   }
	   
	   if(i==textFiles.length){
          
		   File filename = new File("hottopics.txt");
			if (!filename.exists())
				try {
					filename.createNewFile();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}    
		    
		    BufferedWriter bufferedWriter = null;
			try {
				bufferedWriter = new BufferedWriter(new FileWriter(filename));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		   
		  for(String year: keywordsByYear.keySet()){
			     
			  try {
					bufferedWriter.newLine();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
  	    	 try {
					bufferedWriter.write(year);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			  
			  
			      HashMap<String,Integer> hashmap=new HashMap<String, Integer>();
			      Vector<String> keywordsvector=keywordsByYear.get(year); 
			      for(String keywords:keywordsvector){
			    	  String keyword=keywords.toLowerCase();
			    	  if(hashmap.get(keyword)!=null)
			    	      hashmap.put(keyword,hashmap.get(keyword)+1);
			    	  else
			    		  hashmap.put(keyword, 1);	  
			      }
			      
			      Object[] value2 = hashmap.values().toArray() ;
				  Arrays.sort(value2);
				  
				  for(String keyword:hashmap.keySet()){
					 if(value2.length-1>=0){
					  if(hashmap.get(keyword).equals(value2[value2.length-1])){
						  try {
								bufferedWriter.newLine();
							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
		        	    	 try {
								bufferedWriter.write(keyword);
							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
					  
					 }
				  }
				  
				  if(value2.length-2>=0){
					  if(hashmap.get(keyword).equals(value2[value2.length-2])){
						  try {
								bufferedWriter.newLine();
							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
		        	    	 try {
								bufferedWriter.write(keyword);
							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
					  
					 }
				  }
		  
		  if(value2.length-3>=0){
			  if(hashmap.get(keyword).equals(value2[value2.length-3])){
				  try {
						bufferedWriter.newLine();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
        	    	 try {
						bufferedWriter.write(keyword);
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
			  
			 }
		  }
		  
		 }
		}
		
			    
		  try {
			bufferedWriter.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		  try {
			bufferedWriter.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
				      
			  
		  
		
		   
		   
	//   endTime = new Date().getTime();
		
		
		
	       
	   Object[] value1 = keywordsMap.values().toArray() ;
	   Arrays.sort(value1);
	    
	   for(String keywords:keywordsMap.keySet()){
	       
		 //  System.out.println("keywords   "+keywords);
		   
		   if(value1.length-1>=0){
	           if(keywordsMap.get(keywords).equals(value1[value1.length-1])){	
	        	   // System.out.println("");
	        	         System.out.println("1 COMMON TOPICS-keywords:  "+keywords);
	        	        
	        	         boolean flag=false;
	        	         for(String commontopics:commonTopics){
	        	                if(commontopics.equals(keywords)) {
	        	        	          flag=true;
	        	        	          break;
	        	                 }
	        	          } 
	        	    
	        	         if(flag==false)
	        	    	     commonTopics.add(keywords);
	        	    
	           
					if(keywordsFile.containsKey(keywords)){
						 Vector<String> vector=new Vector<String>();
						 vector=keywordsFile.get(keywords);
						 for(int k=0;k<vector.size();k++)
					            System.out.println(vector.get(k));
					 }
		    	} 
	         }
		   
	         
	         if(value1.length-2>=0){
		    	if(keywordsMap.get(keywords).equals(value1[value1.length-2])){
		    		//System.out.println("");
		    		System.out.println("2 COMMON TOPICS-keywords:  "+keywords);
		    		   boolean flag=false;
	        	         for(String commontopics:commonTopics){
	        	                if(commontopics.equals(keywords)) {
	        	        	          flag=true;
	        	        	          break;
	        	                 }
	        	          } 
	        	    
	        	         if(flag==false)
	        	    	     commonTopics.add(keywords);
		    		
					if(keywordsFile.containsKey(keywords)){
						 Vector<String> vector=new Vector<String>();
						 vector=keywordsFile.get(keywords);
						 for(int k=0;k<vector.size();k++)
					            System.out.println(vector.get(k));
					 }
		    	}
	         }
	         
	         
	         if(value1.length-3>=0){
	    	
		    	if(keywordsMap.get(keywords).equals(value1[value1.length-3])){
		    		//System.out.println("");
		    		System.out.println("3 COMMON TOPICS-keywords:  "+keywords);
		    		   boolean flag=false;
	        	         for(String commontopics:commonTopics){
	        	                if(commontopics.equals(keywords)) {
	        	        	          flag=true;
	        	        	          break;
	        	                 }
	        	          } 
	        	    
	        	         if(flag==false)
	        	    	     commonTopics.add(keywords);
		    		
					if(keywordsFile.containsKey(keywords)){
						 Vector<String> vector=new Vector<String>();
						 vector=keywordsFile.get(keywords);
						 for(int k=0;k<vector.size();k++)
					            System.out.println(vector.get(k));
					 }
		    	}//if
	        }//if
	         /*
	         
	         if(value1.length-4>=0){
	    	
		    	if(keywordsMap.get(keywords).equals(value1[value1.length-4])){
		    		//System.out.println("");
		    		System.out.println("4 COMMON TOPICS-keywords:  "+keywords);
		    		   boolean flag=false;
	        	         for(String commontopics:commonTopics){
	        	                if(commontopics.equals(keywords)) {
	        	        	          flag=true;
	        	        	          break;
	        	                 }
	        	          } 
	        	    
	        	         if(flag==false)
	        	    	     commonTopics.add(keywords);
		    		
					if(keywordsFile.containsKey(keywords)){
						 Vector<String> vector=new Vector<String>();
						 vector=keywordsFile.get(keywords);
						 for(int k=0;k<vector.size();k++)
					            System.out.println(vector.get(k));
					 }
		    	}//if
	        }//if
	         
	         
	         
	         if(value1.length-5>=0){
	    	
		    	if(keywordsMap.get(keywords).equals(value1[value1.length-5])){
		    		//System.out.println("");
		    		System.out.println("5 COMMON TOPICS-keywords:  "+keywords);
		    		   boolean flag=false;
	        	         for(String commontopics:commonTopics){
	        	                if(commontopics.equals(keywords)) {
	        	        	          flag=true;
	        	        	          break;
	        	                 }
	        	          } 
	        	    
	        	         if(flag==false)
	        	    	     commonTopics.add(keywords);
		    		
					if(keywordsFile.containsKey(keywords)){
						 Vector<String> vector=new Vector<String>();
						 vector=keywordsFile.get(keywords);
						 for(int k=0;k<vector.size();k++)
					            System.out.println(vector.get(k));
					 }
		    	}//if
	        }//if
	         
	         
	         if(value1.length-6>=0){
	    	
		    	if(keywordsMap.get(keywords).equals(value1[value1.length-6])){
		    		//System.out.println("");
		    		System.out.println("6 COMMON TOPICS-keywords:  "+keywords);
		    		   boolean flag=false;
	        	         for(String commontopics:commonTopics){
	        	                if(commontopics.equals(keywords)) {
	        	        	          flag=true;
	        	        	          break;
	        	                 }
	        	          } 
	        	    
	        	         if(flag==false)
	        	    	     commonTopics.add(keywords);
		    		
					if(keywordsFile.containsKey(keywords)){
						 Vector<String> vector=new Vector<String>();
						 vector=keywordsFile.get(keywords);
						 for(int k=0;k<vector.size();k++)
					            System.out.println(vector.get(k));
					 }
		    	}//if
	        }//if
	         
	         if(value1.length-7>=0){
	 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-7])){
			    		//System.out.println("");
			    		System.out.println("7 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         if(value1.length-8>=0){
	 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-8])){
			    		//System.out.println("");
			    		System.out.println("8 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         
	         if(value1.length-9>=0){
	 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-9])){
			    		//System.out.println("");
			    		System.out.println("9 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         if(value1.length-10>=0){
	 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-10])){
			    		//System.out.println("");
			    		System.out.println("10 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         if(value1.length-11>=0){
		 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-11])){
			    		//System.out.println("");
			    		System.out.println("10 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         if(value1.length-12>=0){
		 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-12])){
			    		//System.out.println("");
			    		System.out.println("10 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         if(value1.length-13>=0){
		 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-13])){
			    		//System.out.println("");
			    		System.out.println("10 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         if(value1.length-14>=0){
		 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-14])){
			    		//System.out.println("");
			    		System.out.println("10 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if
	         
	         if(value1.length-15>=0){
		 	    	
			    	if(keywordsMap.get(keywords).equals(value1[value1.length-15])){
			    		//System.out.println("");
			    		System.out.println("10 COMMON TOPICS-keywords:  "+keywords);
			    		   boolean flag=false;
		        	         for(String commontopics:commonTopics){
		        	                if(commontopics.equals(keywords)) {
		        	        	          flag=true;
		        	        	          break;
		        	                 }
		        	          } 
		        	    
		        	         if(flag==false)
		        	    	     commonTopics.add(keywords);
			    		
						if(keywordsFile.containsKey(keywords)){
							 Vector<String> vector=new Vector<String>();
							 vector=keywordsFile.get(keywords);
							 for(int k=0;k<vector.size();k++)
						            System.out.println(vector.get(k));
						 }
			    	}//if
		        }//if */
	         
	         
	    }//for
	   
	//   System.out.println("MINUTES IT COSTS:"+(endTime-startTime)/1000/60);
	   
	  }// i=506
	
	}//process

}////class

