package fetchKeywords;




import fetchOpinionWords.SWN3;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import opennlp.tools.lang.english.PosTagger;
import opennlp.tools.ngram.Dictionary;

import org.apache.uima.UimaContext;
import org.apache.uima.analysis_component.JCasAnnotator_ImplBase;
import org.apache.uima.analysis_engine.AnalysisEngineProcessException;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.examples.opennlp.Sentence;
import org.apache.uima.examples.opennlp.Token;
import org.apache.uima.jcas.JCas;
import org.apache.uima.resource.ResourceInitializationException;

import annotationType.KeywordsByTF;

public class KeywordsByNouns extends JCasAnnotator_ImplBase {

  //public static final String MODEL_FILE_PARAM = "ModelFile";

 // private PosTagger tagger;
	 public TextFileIndexer index=new TextFileIndexer();
  /**
   * Initialize the Annotator.
   * 
   * @see JCasAnnotator_ImplBase#initialize(UimaContext)
   */
  public void initialize(UimaContext aContext) throws ResourceInitializationException {
    super.initialize(aContext);

    try {
    	index.buildIndex();
    	System.out.println("INDEX DONE");
      // Get configuration parameter values
  //    String modelFile = (String) aContext.getConfigParameterValue(MODEL_FILE_PARAM);
   //   tagger = new PosTagger(modelFile, (Dictionary) null);
    } catch (Exception e) {
      throw new ResourceInitializationException(e);
    }
  }

  /**
   * Process a CAS.
   * 
   * @see JCasAnnotator_ImplBase#process(JCas)
   */
  public void process(JCas aJCas) throws AnalysisEngineProcessException {
    
    ArrayList<Token> tokenList = new ArrayList<Token>();
    ArrayList wordList = new ArrayList();
    HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();
    
  //  HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();

    //int sen=0;
    
    AnnotationIndex sentenceIndex = aJCas.getAnnotationIndex(Sentence.type);
    AnnotationIndex tokenIndex = aJCas.getAnnotationIndex(Token.type);

    // iterate over Sentences
    FSIterator sentenceIterator = sentenceIndex.iterator();
    while (sentenceIterator.hasNext()) {
    
     //  System.out.println("-------SENTENCE--------");
       	
   
      Sentence sentence = (Sentence) sentenceIterator.next();

  //    tokenList.clear();
    //  wordList.clear();

      // iterate over Tokens
      FSIterator tokenIterator = tokenIndex.subiterator(sentence);
     
      while (tokenIterator.hasNext()) {
       
    	Token token = (Token) tokenIterator.next();
        
    	tokenList.add(token);
        
    	String posTag = token.getPosTag();
    	
        if(posTag!=null&&posTag.equals("NN")||posTag.equals("NNS")||posTag.equals("NNP")){
           
                   if(tokenList1.get(token.getCoveredText()) != null){
     				tokenList1.put(token.getCoveredText(),tokenList1.get(token.getCoveredText())+1);
        	        System.out.println("keywords"+token.getCoveredText());
                   }
                   else{
                	   tokenList1.put(token.getCoveredText(),1); 
                   }         
             }
        	 
        
            }
           
        
      }
    
   
            
    Object[] value =  tokenList1.values().toArray() ;
    Arrays.sort(value);
  //  for(int i=0;i<value.length;i++)
    //    System.out.println(value[i]);
    //int i=0;
  //  System.out.println(tokenList1.keySet());
    
    for(Object o:tokenList1.keySet()){
    	//System.out.println("????"+tokenList1.get(o));
    	if(tokenList1.get(o).equals(value[value.length-1])||tokenList1.get(o).equals(value[value.length-2])||tokenList1.get(o).equals(value[value.length-3])){
             
    		 for(int i=0; i<tokenList.size();i++){
    			if(tokenList.get(i).getCoveredText().equals(o)){
    		           KeywordsByTF keywords=new KeywordsByTF(aJCas); 
                       keywords.setBegin(tokenList.get(i).getBegin());
                       keywords.setEnd(tokenList.get(i).getEnd());
                       keywords.addToIndexes();       
                   }
             }
    	}
    }
  }
}
