package fetchKeywords;





import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import org.apache.lucene.index.Term;
import org.apache.uima.UimaContext;
import org.apache.uima.analysis_component.JCasAnnotator_ImplBase;
import org.apache.uima.analysis_engine.AnalysisEngineProcessException;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.examples.opennlp.Sentence;
import org.apache.uima.examples.opennlp.Token;
import org.apache.uima.jcas.JCas;
import org.apache.uima.resource.ResourceInitializationException;
import annotationType.KeywordsByTFDF;


public class KeywordsByTFandDF extends JCasAnnotator_ImplBase {

  //public static final String MODEL_FILE_PARAM = "ModelFile";
  public TextFileIndexer index=new TextFileIndexer();
  public int i=0;
  public double time=0.0;
 // private PosTagger tagger;

  /**
   * Initialize the Annotator.
   * 
   * @see JCasAnnotator_ImplBase#initialize(UimaContext)
   */
  public void initialize(UimaContext aContext) throws ResourceInitializationException {
    super.initialize(aContext);
    try {
      // Get configuration parameter values
    	index.buildIndex();
    	System.out.println("INDEX DONE");
  //    String modelFile = (String) aContext.getConfigParameterValue(MODEL_FILE_PARAM);
   //   tagger = new PosTagger(modelFile, (Dictionary) null);
    } catch (Exception e) {
      throw new ResourceInitializationException(e);
    }
  }

  /**
   * Process a CAS.
   * 
   * @see JCasAnnotator_ImplBase#process(JCas)
   */
  public void process(JCas aJCas) throws AnalysisEngineProcessException {
    
    ArrayList<Token> tokenList = new ArrayList<Token>();
    ArrayList wordList = new ArrayList();
    HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();
    ArrayList<Term> tfdf=null;
    System.out.println("---------------------------------------");
    System.out.println(i);
    long startTime = new Date().getTime();
    if(i<index.documentsNumber){
    	
	try {
		tfdf = index.tfdf(i);
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
  //  System.out.println("tfdf...."+tfdf.size());
  //  HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();

    //int sen=0;
    
    AnnotationIndex sentenceIndex = aJCas.getAnnotationIndex(Sentence.type);
    AnnotationIndex tokenIndex = aJCas.getAnnotationIndex(Token.type);

    // iterate over Sentences
    FSIterator sentenceIterator = sentenceIndex.iterator();
    while (sentenceIterator.hasNext()) {
    
     //  System.out.println("-------SENTENCE--------");
       	
      Sentence sentence = (Sentence) sentenceIterator.next();

  //    tokenList.clear();
    //  wordList.clear();

      // iterate over Tokens
      FSIterator tokenIterator = tokenIndex.subiterator(sentence);
     
      while (tokenIterator.hasNext()) {
       
    	Token token = (Token) tokenIterator.next();
        
    	tokenList.add(token);
        //System.out.println(token.getCoveredText());
   
             
				for(int j=0; j<tfdf.size();j++)
                
				{	   
						
					      if(token.getCoveredText().toLowerCase().equals(tfdf.get(j).text().toLowerCase()))
						   {   
							   KeywordsByTFDF keywords=new KeywordsByTFDF(aJCas); 
					           keywords.setBegin(token.getBegin());
					           keywords.setEnd(token.getEnd());
					           keywords.addToIndexes();   
					           System.out.println("document"+i+" keywords:"+keywords.getCoveredText());
						   }
						   
						   
				}
		} 
	 } 
          i++;
          }
    
    long endTime = new Date().getTime();
    time=time+(endTime-startTime);
    System.out.println("It took " + time/1000/60 + "minutes");
   }
       
 }
   

