package fetchOpinionWords;



import fetchKeywords.KeywordsByNounPlus;
import fetchOpinionWords.SWN3;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import opennlp.tools.lang.english.PosTagger;
import opennlp.tools.ngram.Dictionary;

import org.apache.uima.UimaContext;
import org.apache.uima.analysis_component.JCasAnnotator_ImplBase;
import org.apache.uima.analysis_engine.AnalysisEngineProcessException;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.examples.opennlp.Sentence;
import org.apache.uima.examples.opennlp.Token;
import org.apache.uima.jcas.JCas;
import org.apache.uima.resource.ResourceInitializationException;

import annotationType.KeywordsByTF;
import annotationType.SentimentWords;

public class FetchSentimentWords extends JCasAnnotator_ImplBase {

  //public static final String MODEL_FILE_PARAM = "ModelFile";
   public SWN3 swn;
   public SubLexicon sub;
 //  public int i=0;
   public HashMap<String, Vector<String>> files=new HashMap<String,Vector<String>>();
   public HashMap<String,Vector<String>> sentiwordsByYear=new HashMap<String,Vector<String>>();
   public HashMap<String,Vector<String>> sentiwordsByType=new HashMap<String,Vector<String>>();
   public  HashMap<String, Vector<String>> stringAdj=new  HashMap<String, Vector<String>>();
  
 // private PosTagger tagger;

  /**
   * Initialize the Annotator.
   * 
   * @see JCasAnnotator_ImplBase#initialize(UimaContext)
   */
  public void initialize(UimaContext aContext) throws ResourceInitializationException {
    super.initialize(aContext);

    try {
    	swn=new SWN3();
    	sub=new SubLexicon();
      // Get configuration parameter values
  //    String modelFile = (String) aContext.getConfigParameterValue(MODEL_FILE_PARAM);
   //   tagger = new PosTagger(modelFile, (Dictionary) null);
    } catch (Exception e) {
      throw new ResourceInitializationException(e);
    }
  }

  /**
   * Process a CAS.
   * 
   * @see JCasAnnotator_ImplBase#process(JCas)
   */
  public void process(JCas aJCas) throws AnalysisEngineProcessException {
    
   // if(i<KeywordsByNounPlus.textFiles.length){  
	
	String year=KeywordsByNounPlus.year;
	String type=KeywordsByNounPlus.type;
    ArrayList<Token> tokenList = new ArrayList<Token>();
    ArrayList<KeywordsByTF> keywordsList = new ArrayList<KeywordsByTF>();	
    HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();
    
  //  HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();

    //int sen=0;
    
    AnnotationIndex sentenceIndex = aJCas.getAnnotationIndex(Sentence.type);
    AnnotationIndex tokenIndex = aJCas.getAnnotationIndex(Token.type);
    AnnotationIndex keywordsIndex = aJCas.getAnnotationIndex(KeywordsByTF.type);
	FSIterator keywordsIterator = keywordsIndex.iterator();
	 
    while (keywordsIterator.hasNext()) {
		   
		   KeywordsByTF keywords = (KeywordsByTF) keywordsIterator.next();
	       keywordsList.add(keywords);
	}
   
    for(int j=0;j<keywordsList.size();j++){
    	System.out.println("++++++++++++"+keywordsList.get(j).getCoveredText());
    }
    
    
    
    // iterate over Sentences
    FSIterator sentenceIterator = sentenceIndex.iterator();
    while (sentenceIterator.hasNext()) {
    
    	
     //  System.out.println("-------SENTENCE--------");
       	
    	Vector<String> subwords=new Vector<String>();
      Sentence sentence = (Sentence) sentenceIterator.next();

      tokenList.clear();
    //  wordList.clear();

      // iterate over Tokens
      FSIterator tokenIterator = tokenIndex.subiterator(sentence);
     
      while (tokenIterator.hasNext()) {
       
    	Token token = (Token) tokenIterator.next();	
    	tokenList.add(token); 
        
      }
      
      ///subjective words by sentence
      for(int i=0;i<tokenList.size();i++){
    	 
    	  Token token=tokenList.get(i);
    	  String pos=token.getPosTag();
    	  String postag=null;
    	  
    	  if(pos!=null&&pos.equals("JJ")||pos.equals("JJR")||pos.equals("JJS"))
    		  postag="adj";
          
    	  if(pos!=null&&pos.equals("RB")||pos.equals("RBR")||pos.equals("RBS"))
    	  
    	     postag="adverb";
    	  
    	  if(pos!=null&&pos.equals("VB")||pos.equals("VBD")||pos.equals("VBG")||pos.equals("VBN")||pos.equals("VBP")||pos.equals("VBZ"))
    		
             postag="verb";
    	 
    	  if(pos!=null&&pos.equals("NN")||pos.equals("NNS")||pos.equals("NNP")||pos.equals("NNPS"))
    	         
    		  postag="noun";

    	  
    	  if(sub.extract(token.getCoveredText().toLowerCase(), postag)!=null&&!sub.extract(token.getCoveredText().toLowerCase(), postag).elementAt(3).equals("neutral")){  		  
    		   subwords.add(token.getCoveredText()+"#"+postag);
    		   SentimentWords sentiwords=new SentimentWords(aJCas); 
               sentiwords.setBegin(token.getBegin());
               sentiwords.setEnd(token.getEnd());
               sentiwords.addToIndexes();
    	  }
    	  
    	 
    	  
      } 
      
      
      
     for(int i=0;i<tokenList.size();i++){
    	
    	Token token=tokenList.get(i);
    
    	
    	Token token1=null;
        Token token2=null;
        Token token3=null;
        Token token4=null;
        
     
      if((i-2)>=0)
         token1= (Token) tokenList.get(i-2);
      if((i-1)>=0)
      	 token2= (Token) tokenList.get(i-1);
      if((i+1)<tokenList.size())
      	 token3= (Token) tokenList.get(i+1);
      if((i+2)<tokenList.size())
      	 token4= (Token) tokenList.get(i+2);
        
       for(int j=0;j<keywordsList.size();j++){
    		     
           if(token.getCoveredText().equals(keywordsList.get(j).getCoveredText())){    
    			   	  
  
        	   if(subwords!=null){
        		 
        			   for(String subword:subwords){
 	            	  	        	
       	            	  if(sentiwordsByYear.containsKey(year)){
       	            		  boolean flag=false;
       	            		  Vector<String> sentiwords1=new Vector<String>();
       	            		  sentiwords1=sentiwordsByYear.get(year);
       	            		  for(int k=0;k<sentiwords1.size();k++){
       	            			  if(subword.equals(sentiwords1.get(k))){
       	            				  flag=true;
       	            				  break;
       	            			  }					  
       	            			 
       	            		  }
       	            		  
       	            		  if(flag==false)
       	            		        sentiwords1.add(subword);
       	            		  
       	            		  sentiwordsByYear.put(year, sentiwords1);
       	            		  
       	            	  }
       	            	  
       	            	  else
       	            	  {
       	            		  Vector<String> sentiwords1=new Vector<String>();
       	            		  sentiwords1.add(subword);
       	            		  sentiwordsByYear.put(year, sentiwords1);
       	            		  
       	            	  }
       	            	  
       	            	  if(sentiwordsByType.containsKey(type)){
       	            		  boolean flag=false;
       	            		  Vector<String> sentiwords1=new Vector<String>();
       	            		  sentiwords1=sentiwordsByType.get(type);
       	            		  for(int k=0;k<sentiwords1.size();k++){
       	            			  if(subword.equals(sentiwords1.get(k))){
       	            				  flag=true;
       	            				  break;
       	            			  }					  
       	            			 
       	            		  }
       	            		  
       	            		  if(flag==false)
       	            		        sentiwords1.add(subword);
       	            		  
       	            		  sentiwordsByType.put(type, sentiwords1);
       	            		  
       	            	  }
       	            	  
       	            	  else
       	            	  {
       	            		  Vector<String> sentiwords1=new Vector<String>();
       	            		  sentiwords1.add(subword);
       	            		  sentiwordsByType.put(type, sentiwords1);
       	            	  }
       	            	  
                             
                             
       	            	  if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                               Vector<String> adj=new Vector<String>();
       	            	       adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
                                  boolean flag=false;
       	            	       for(int k=0;k<adj.size();k++){
                               	   if(adj.get(k).equals(subword)){
                               		  flag=true;
                               	   }
       	            	       }	
       	            	       
                                  if(flag==false)	   
       	            	           adj.add(subword);
                                  
       	            		   stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
       	            	 
       	            	  }
       	            	  else
       	            	  {
       	            		  Vector<String> adj=new Vector<String>();
       	            		  adj.add(subword);
       	            		  stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
       	            	  }
        			    	 
        			    	 
        			    }
        	   }
        	  
        	   
        
    			   
    		     if(token1!=null){
    			   //System.out.println("XXXXXXXXXXXXXx"+token1.getCoveredText().toLowerCase());
    			   //System.out.println("XXXXXXXXXXXXXx"+token1.getPosTag());
    	          if(token1.getPosTag().equals("JJ")||token1.getPosTag().equals("JJR")||token1.getPosTag().equals("JJS")){
    	        	if(swn.extract(token1.getCoveredText().toLowerCase(),"a")!=null){
    	        	  Vector<Double> vector=new Vector<Double>(); 
    	        	  vector=swn.extract(token1.getCoveredText().toLowerCase(),"a");
    	              if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){
    	            	  System.out.println(token.getCoveredText()+"token1:"+token1.getCoveredText());
    	            	  
    	            	  SentimentWords sentiwords=new SentimentWords(aJCas); 
                          sentiwords.setBegin(token1.getBegin());
                          sentiwords.setEnd(token1.getEnd());
                          sentiwords.addToIndexes();
    	            	  
    	            	  if(sentiwordsByYear.containsKey(year)){
    	            		  boolean flag=false;
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1=sentiwordsByYear.get(year);
    	            		  for(int k=0;k<sentiwords1.size();k++){
    	            			  if(token1.getCoveredText().equals(sentiwords1.get(k))){
    	            				  flag=true;
    	            				  break;
    	            			  }					  
    	            			 
    	            		  }
    	            		  
    	            		  if(flag==false)
    	            		        sentiwords1.add(token1.getCoveredText()+"#"+"adj");
    	            		  
    	            		  sentiwordsByYear.put(year, sentiwords1);
    	            		  
    	            	  }
    	            	  
    	            	  else
    	            	  {
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1.add(token1.getCoveredText()+"#"+"adj");
    	            		  sentiwordsByYear.put(year, sentiwords1);
    	            		  
    	            	  }
    	            	  
    	            	  if(sentiwordsByType.containsKey(type)){
    	            		  boolean flag=false;
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1=sentiwordsByType.get(type);
    	            		  for(int k=0;k<sentiwords1.size();k++){
    	            			  if(token1.getCoveredText().equals(sentiwords1.get(k))){
    	            				  flag=true;
    	            				  break;
    	            			  }					  
    	            			 
    	            		  }
    	            		  
    	            		  if(flag==false)
    	            		        sentiwords1.add(token1.getCoveredText()+"#"+"adj");
    	            		  
    	            		  sentiwordsByType.put(type, sentiwords1);
    	            		  
    	            	  }
    	            	  
    	            	  else
    	            	  {
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1.add(token1.getCoveredText()+"#"+"adj");
    	            		  sentiwordsByType.put(type, sentiwords1);
    	            	  }
    	            	  
                          
                          
    	            	  if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                               Vector<String> adj=new Vector<String>();
    	            	       adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
                               boolean flag=false;
    	            	       for(int k=0;k<adj.size();k++){
                            	   if(adj.get(k).equals(token1.getCoveredText())){
                            		  flag=true;
                            	   }
    	            	       }	
    	            	       
                               if(flag==false)	   
    	            	           adj.add(token1.getCoveredText()+"#"+"adj");
                               
    	            		   stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
    	            	 
    	            	  }
    	            	  else
    	            	  {
    	            		  Vector<String> adj=new Vector<String>();
    	            		  adj.add(token1.getCoveredText()+"#"+"adj");
    	            		  stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
    	            	  }
    	            	 
    	       	         
    	              }//if
    	             }//if
    	         }//if
    	          
    	          if(token1.getPosTag().equals("RB")||token1.getPosTag().equals("RBR")||token1.getPosTag().equals("RBS")){
    	            if(swn.extract(token1.getCoveredText().toLowerCase(),"r")!=null){
    	            	 Vector<Double> vector=new Vector<Double>(); 
       	        	     vector=swn.extract(token1.getCoveredText().toLowerCase(),"r");
    	              if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){
    	       	          SentimentWords sentiwords=new SentimentWords(aJCas); 
                          sentiwords.setBegin(token1.getBegin());
                          sentiwords.setEnd(token1.getEnd());
                          sentiwords.addToIndexes();
                     //     System.out.println(token.getCoveredText()+"token1:"+token1.getCoveredText());
                        //  for(String commonkeywords:KeywordsByNounPlus.commonTopics){
	    	              //    if(commonkeywords.equals(keywordsList.get(j).getCoveredText())){
	    	                
                          
                          if(sentiwordsByYear.containsKey(year)){
    	            		  boolean flag=false;
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1=sentiwordsByYear.get(year);
    	            		  for(int k=0;k<sentiwords1.size();k++){
    	            			  if(token1.getCoveredText().equals(sentiwords1.get(k))){
    	            				  flag=true;
    	            				  break;
    	            			  }					  
    	            			 
    	            		  }
    	            		  
    	            		  if(flag==false)
    	            		        sentiwords1.add(token1.getCoveredText()+"#"+"adverb");
    	            		  
    	            		  sentiwordsByYear.put(year, sentiwords1);
    	            		  
    	            	  }
    	            	  
    	            	  else
    	            	  {
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1.add(token1.getCoveredText()+"#"+"adverb");
    	            		  sentiwordsByYear.put(year, sentiwords1);
    	            		  
    	            	  }
    	            	  
    	            	  if(sentiwordsByType.containsKey(type)){
    	            		  boolean flag=false;
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1=sentiwordsByType.get(type);
    	            		  for(int k=0;k<sentiwords1.size();k++){
    	            			  if(token1.getCoveredText().equals(sentiwords1.get(k))){
    	            				  flag=true;
    	            				  break;
    	            			  }					  
    	            			 
    	            		  }
    	            		  
    	            		  if(flag==false)
    	            		        sentiwords1.add(token1.getCoveredText()+"#"+"adverb");
    	            		  
    	            		  sentiwordsByType.put(type, sentiwords1);
    	            		  
    	            	  }
    	            	  
    	            	  else
    	            	  {
    	            		  Vector<String> sentiwords1=new Vector<String>();
    	            		  sentiwords1.add(token1.getCoveredText()+"#"+"adverb");
    	            		  sentiwordsByType.put(type, sentiwords1);
    	            		  
    	            	  }
                          
                          
                          
                          
                          
                          if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                              Vector<String> adj=new Vector<String>();
   	            	          adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
   	            	        boolean flag=false;
	            	       for(int k=0;k<adj.size();k++){
                        	   if(adj.get(k).equals(token1.getCoveredText())){
                        		  flag=true;
                        	   }
	            	       }	
	            	       
                           if(flag==false)	   
	            	           adj.add(token1.getCoveredText()+"#"+"adverb");
                              
   	            		      stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
   	            		     }
   	            	      else
   	            	       {
   	            		       Vector<String> adj=new Vector<String>();
   	            		       adj.add(token1.getCoveredText()+"#"+"adverb");
   	            		       stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
   	            	      } 
	                   }//if 0.0
    	            	
    	              }//if !null
    	              }//if RB
    	         } //if !null
    	          
    		
    		   
    		     if(token2!=null){
    		    	 //System.out.println(token2.getCoveredText().toLowerCase());
      		  
      	          if(token2.getPosTag().equals("JJ")||token2.getPosTag().equals("JJR")||token2.getPosTag().equals("JJS")){
      	       	     if(swn.extract(token2.getCoveredText().toLowerCase(),"a")!=null){
      	       		 Vector<Double> vector=new Vector<Double>(); 
   	        	     vector=swn.extract(token2.getCoveredText().toLowerCase(),"a");
	                 if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){
      	       	            SentimentWords sentiwords=new SentimentWords(aJCas); 
                            sentiwords.setBegin(token2.getBegin());
                            sentiwords.setEnd(token2.getEnd());
                            sentiwords.addToIndexes();
                            System.out.println(token.getCoveredText()+"token2:"+token2.getCoveredText());
                            
                            if(sentiwordsByYear.containsKey(year)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByYear.get(year);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token2.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token2.getCoveredText()+"#"+"adj");
      	            		  
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token2.getCoveredText()+"#"+"adj");
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  if(sentiwordsByType.containsKey(type)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByType.get(type);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token2.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token2.getCoveredText()+"#"+"adj");
      	            		  
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token2.getCoveredText()+"#"+"adj");
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
                            
                            
                            
                            
                            
                            if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                                Vector<String> adj=new Vector<String>();
     	            	       adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
     	            	       boolean flag=false;
   	            	           for(int k=0;k<adj.size();k++){
                           	   if(adj.get(k).equals(token2.getCoveredText())){
                           		   flag=true;
                           	     }
   	            	          }	
   	            	       
                              if(flag==false)	   
   	            	           adj.add(token2.getCoveredText()+"#"+"adj");
     	            		   stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            		   }
     	            	  else
     	            	  {
     	            		  Vector<String> adj=new Vector<String>();
     	            		  adj.add(token2.getCoveredText()+"#"+"adj");
     	            		  stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            	  }
      	              }
	                 }
      	         }
      	          
      	          if(token2.getPosTag().equals("RB")||token2.getPosTag().equals("RBR")||token2.getPosTag().equals("RBS")){
      	        	if(swn.extract(token2.getCoveredText().toLowerCase(),"r")!=null){
      	        		 Vector<Double> vector=new Vector<Double>(); 
       	        	     vector=swn.extract(token2.getCoveredText().toLowerCase(),"r");
    	              if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){
      	       	          SentimentWords sentiwords=new SentimentWords(aJCas); 
                            sentiwords.setBegin(token2.getBegin());
                            sentiwords.setEnd(token2.getEnd());
                            sentiwords.addToIndexes();
                            System.out.println(token.getCoveredText()+"token2:"+token2.getCoveredText());
                            
                            if(sentiwordsByYear.containsKey(year)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByYear.get(year);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token2.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token2.getCoveredText()+"#"+"adverb");
      	            		  
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token2.getCoveredText()+"#"+"adverb");
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  if(sentiwordsByType.containsKey(type)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByType.get(type);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token2.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token2.getCoveredText()+"#"+"adverb");
      	            		  
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token2.getCoveredText()+"#"+"adverb");
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
                            
                            
                            
                            if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                                Vector<String> adj=new Vector<String>();
     	            	       adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
     	            	      boolean flag=false;
   	            	       for(int k=0;k<adj.size();k++){
                           	   if(adj.get(k).equals(token2.getCoveredText())){
                           		  flag=true;
                           	   }
   	            	       }	
   	            	       
                              if(flag==false)	   
   	            	           adj.add(token2.getCoveredText()+"#"+"adverb");
     	            		   stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            		   }
     	            	  else
     	            	  {
     	            		  Vector<String> adj=new Vector<String>();
     	            		  adj.add(token2.getCoveredText()+"#"+"adverb");
     	            		  stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            	  }
      	                 }
    	              }
      	         } 
      	         
      		}
    		     
    		     
    		     if(token3!=null){
    		  //  	 System.out.println(token3.getCoveredText().toLowerCase());
      		  
      	          if(token3.getPosTag().equals("JJ")||token3.getPosTag().equals("JJR")||token3.getPosTag().equals("JJS")){
      	        	if(swn.extract(token3.getCoveredText().toLowerCase(),"a")!=null){
      	        		 Vector<Double> vector=new Vector<Double>(); 
       	        	     vector=swn.extract(token3.getCoveredText().toLowerCase(),"a");
    	              if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){{
      	       	            SentimentWords sentiwords=new SentimentWords(aJCas); 
                            sentiwords.setBegin(token3.getBegin());
                            sentiwords.setEnd(token3.getEnd());
                            sentiwords.addToIndexes();
                            System.out.println(token.getCoveredText()+"token3:"+token3.getCoveredText());
                            
                            if(sentiwordsByYear.containsKey(year)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByYear.get(year);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token3.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token3.getCoveredText()+"#"+"adj");
      	            		  
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token3.getCoveredText()+"#"+"adj");
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  if(sentiwordsByType.containsKey(type)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByType.get(type);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token3.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token3.getCoveredText()+"#"+"adj");
      	            		  
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token3.getCoveredText()+"#"+"adj");
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
                            
                            
                            
                            if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                                Vector<String> adj=new Vector<String>();
     	            	       adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
     	            	      boolean flag=false;
   	            	       for(int k=0;k<adj.size();k++){
                           	   if(adj.get(k).equals(token3.getCoveredText())){
                           		  flag=true;
                           	   }
   	            	       }	
   	            	       
                              if(flag==false)	   
   	            	           adj.add(token3.getCoveredText()+"#"+"adj");
     	            		   stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            		   }
     	            	  else
     	            	  {
     	            		  Vector<String> adj=new Vector<String>();
     	            		  adj.add(token3.getCoveredText()+"#"+"adj");
     	            		  stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            	  }
                             
      	              }
    	             }
      	         }
      	          
      	          if(token3.getPosTag().equals("RB")||token3.getPosTag().equals("RBR")||token3.getPosTag().equals("RBS")){
      	        	if(swn.extract(token3.getCoveredText().toLowerCase(),"r")!=null){
      	        		 Vector<Double> vector=new Vector<Double>(); 
       	        	     vector=swn.extract(token3.getCoveredText().toLowerCase(),"r");
    	              if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){
      	       	          SentimentWords sentiwords=new SentimentWords(aJCas); 
                            sentiwords.setBegin(token3.getBegin());
                            sentiwords.setEnd(token3.getEnd());
                            sentiwords.addToIndexes();
                            //System.out.println(token.getCoveredText()+"token3:"+token3.getCoveredText());
                            
                            if(sentiwordsByYear.containsKey(year)){
        	            		  boolean flag=false;
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1=sentiwordsByYear.get(year);
        	            		  for(int k=0;k<sentiwords1.size();k++){
        	            			  if(token3.getCoveredText().equals(sentiwords1.get(k))){
        	            				  flag=true;
        	            				  break;
        	            			  }					  
        	            			 
        	            		  }
        	            		  
        	            		  if(flag==false)
        	            		        sentiwords1.add(token3.getCoveredText()+"#"+"adverb");
        	            		  
        	            		  sentiwordsByYear.put(year, sentiwords1);
        	            		  
        	            	  }
        	            	  
        	            	  else
        	            	  {
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1.add(token3.getCoveredText()+"#"+"adverb");
        	            		  sentiwordsByYear.put(year, sentiwords1);
        	            		  
        	            	  }
        	            	  
        	            	  if(sentiwordsByType.containsKey(type)){
        	            		  boolean flag=false;
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1=sentiwordsByType.get(type);
        	            		  for(int k=0;k<sentiwords1.size();k++){
        	            			  if(token3.getCoveredText().equals(sentiwords1.get(k))){
        	            				  flag=true;
        	            				  break;
        	            			  }					  
        	            			 
        	            		  }
        	            		  
        	            		  if(flag==false)
        	            		        sentiwords1.add(token3.getCoveredText()+"#"+"adverb");
        	            		  
        	            		  sentiwordsByType.put(type, sentiwords1);
        	            		  
        	            	  }
        	            	  
        	            	  else
        	            	  {
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1.add(token3.getCoveredText()+"#"+"adverb");
        	            		  sentiwordsByType.put(type, sentiwords1);
        	            		  
        	            	  }
                            
                            
                            
                            if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                                Vector<String> adj=new Vector<String>();
     	            	       adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
     	            	      boolean flag=false;
   	            	       for(int k=0;k<adj.size();k++){
                           	   if(adj.get(k).equals(token3.getCoveredText())){
                           		  flag=true;
                           	   }
   	            	       }	
   	            	       
                              if(flag==false)	   
   	            	           adj.add(token3.getCoveredText()+"#"+"adverb");
     	            		   stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            		   }
     	            	  else
     	            	  {
     	            		  Vector<String> adj=new Vector<String>();
     	            		  adj.add(token3.getCoveredText()+"#"+"adverb");
     	            		  stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            	  }
                            
                           
      	              }}
      	         } 
      	         
      		}
    		     
    		     if(token4!=null){
    		  //  	 System.out.println(token4.getCoveredText().toLowerCase());
      		  
      	          if(token4.getPosTag().equals("JJ")||token4.getPosTag().equals("JJR")||token4.getPosTag().equals("JJS")){
      	        	if(swn.extract(token4.getCoveredText().toLowerCase(),"a")!=null){
      	        		 Vector<Double> vector=new Vector<Double>(); 
       	        	     vector=swn.extract(token4.getCoveredText().toLowerCase(),"a");
    	              if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){
      	       	          SentimentWords sentiwords=new SentimentWords(aJCas); 
                            sentiwords.setBegin(token4.getBegin());
                            sentiwords.setEnd(token4.getEnd());
                            sentiwords.addToIndexes();
                            System.out.println(token.getCoveredText()+"token4"+token4.getCoveredText());
                            
                            if(sentiwordsByYear.containsKey(year)){
        	            		  boolean flag=false;
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1=sentiwordsByYear.get(year);
        	            		  for(int k=0;k<sentiwords1.size();k++){
        	            			  if(token4.getCoveredText().equals(sentiwords1.get(k))){
        	            				  flag=true;
        	            				  break;
        	            			  }					  
        	            			 
        	            		  }
        	            		  
        	            		  if(flag==false)
        	            		        sentiwords1.add(token4.getCoveredText()+"#"+"adj");
        	            		  
        	            		  sentiwordsByYear.put(year, sentiwords1);
        	            		  
        	            	  }
        	            	  
        	            	  else
        	            	  {
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1.add(token4.getCoveredText()+"#"+"adj");
        	            		  sentiwordsByYear.put(year, sentiwords1);
        	            		  
        	            	  }
        	            	  
        	            	  if(sentiwordsByType.containsKey(type)){
        	            		  boolean flag=false;
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1=sentiwordsByType.get(type);
        	            		  for(int k=0;k<sentiwords1.size();k++){
        	            			  if(token4.getCoveredText().equals(sentiwords1.get(k))){
        	            				  flag=true;
        	            				  break;
        	            			  }					  
        	            			 
        	            		  }
        	            		  
        	            		  if(flag==false)
        	            		        sentiwords1.add(token4.getCoveredText()+"#"+"adj");
        	            		  
        	            		  sentiwordsByType.put(type, sentiwords1);
        	            		  
        	            	  }
        	            	  
        	            	  else
        	            	  {
        	            		  Vector<String> sentiwords1=new Vector<String>();
        	            		  sentiwords1.add(token4.getCoveredText()+"#"+"adj");
        	            		  sentiwordsByType.put(type, sentiwords1);
        	            		  
        	            	  }
                            
                            
                            
                            if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                                Vector<String> adj=new Vector<String>();
     	            	        adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
     	            	       boolean flag=false;
    	            	       for(int k=0;k<adj.size();k++){
                            	   if(adj.get(k).equals(token4.getCoveredText())){
                            		  flag=true;
                            	   }
    	            	       }	
    	            	       
                               if(flag==false)	   
    	            	           adj.add(token4.getCoveredText()+"#"+"adj");
     	            		    stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            		   }
     	            	  else
     	            	  {
     	            		  Vector<String> adj=new Vector<String>();
     	            		  adj.add(token4.getCoveredText()+"#"+"adj");
     	            		  stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            	  }
                        }
    	              }
      	         }
      	          
      	          if(token4.getPosTag().equals("RB")||token4.getPosTag().equals("RBR")||token4.getPosTag().equals("RBS")){
      	        	if(swn.extract(token4.getCoveredText().toLowerCase(),"r")!=null){
      	        		 Vector<Double> vector=new Vector<Double>(); 
       	        	     vector=swn.extract(token4.getCoveredText().toLowerCase(),"r");
    	              if((1-vector.elementAt(0)-vector.elementAt(1))!=1.0){
      	       	            SentimentWords sentiwords=new SentimentWords(aJCas); 
                            sentiwords.setBegin(token4.getBegin());
                            sentiwords.setEnd(token4.getEnd());
                            sentiwords.addToIndexes();
                            System.out.println(token.getCoveredText()+"token4:"+token4.getCoveredText());
                            
                            if(sentiwordsByYear.containsKey(year)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByYear.get(year);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token4.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token4.getCoveredText()+"#"+"adverb");
      	            		  
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token4.getCoveredText()+"#"+"adverb");
      	            		  sentiwordsByYear.put(year, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  if(sentiwordsByType.containsKey(type)){
      	            		  boolean flag=false;
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1=sentiwordsByType.get(type);
      	            		  for(int k=0;k<sentiwords1.size();k++){
      	            			  if(token4.getCoveredText().equals(sentiwords1.get(k))){
      	            				  flag=true;
      	            				  break;
      	            			  }					  
      	            			 
      	            		  }
      	            		  
      	            		  if(flag==false)
      	            		        sentiwords1.add(token4.getCoveredText()+"#"+"adverb");
      	            		  
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
      	            	  
      	            	  else
      	            	  {
      	            		  Vector<String> sentiwords1=new Vector<String>();
      	            		  sentiwords1.add(token4.getCoveredText()+"#"+"adverb");
      	            		  sentiwordsByType.put(type, sentiwords1);
      	            		  
      	            	  }
                            
                            
                            
                            
                          if(stringAdj.containsKey(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName())){
                                Vector<String> adj=new Vector<String>();
     	            	        adj=stringAdj.get(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName());
     	            	       boolean flag=false;
    	            	       for(int k=0;k<adj.size();k++){
                            	   if(adj.get(k).equals(token4.getCoveredText())){
                            		  flag=true;
                            	   }
    	            	       }	
    	            	       
                               if(flag==false)	   
    	            	           adj.add(token4.getCoveredText()+"#"+"adverb");
     	            		    stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	                  }
     	            	  else{
     	            		    Vector<String> adj=new Vector<String>();
     	            		    adj.add(token4.getCoveredText()+"#"+"adverb");
     	            		    stringAdj.put(token.getCoveredText()+"|"+KeywordsByNounPlus.textFiles[KeywordsByNounPlus.i-1].getName(),adj);
     	            	  }
       
      	              }//if
    	            }//if
      	         } //if
      	         
      		}//if token[n]!=null
    		     
    	   }//if equal	   
        	        
         }  //if equal  
    
      }//for keywordslist
    	
   }//for token
   
 }//whilesentence
    
//sentence
  //  i++;
 //}//if
    
    if(KeywordsByNounPlus.i==KeywordsByNounPlus.textFiles.length){
    	
    	System.out.println("----------CHANGE-------------------");
    	ArrayList<String> years=new ArrayList<String>();
    	BufferedWriter bufferedWriter;

		try{
				
				File filename = new File("result.txt");
				//if (!filename.exists()) 
			    filename.createNewFile();    
			    bufferedWriter = new BufferedWriter(new FileWriter(filename));
						
       
    	for(String commontopics: KeywordsByNounPlus.commonTopics){
    	    
    		System.out.println("");
    	    System.out.println("");
    	    System.out.println("COMMON TOPICS:"+commontopics);
    	    bufferedWriter.newLine();
    	    bufferedWriter.write("COMMON TOPICS:"+commontopics);
    	    
    	    HashMap<String,Vector<String>> arraylist=new HashMap<String,Vector<String>>();
    	 //   String[] string = null;
			
    	    for(String key: stringAdj.keySet()){
    	       // System.out.println(key+","+stringAdj.get(key));
				String[] string=key.split("\\|");
				String string0=string[0];
				String string1=string[1];
				//System.out.println(string0);
			    String[] strings=string1.split("-");
				String yearandtypes=strings[0];
			    String[] yearandtype=yearandtypes.split("_");
				String year1=yearandtype[0];
				String type1=yearandtype[1];
				
				if(commontopics.equals(string0)){
			    	arraylist.put(key,stringAdj.get(key));
				}
				
			 }//for
			
		    ArrayList<String> yearset=new ArrayList<String>();	
		    
		    for(String key: arraylist.keySet()){
				String[] string=key.split("\\|");
				String string0=string[0];
				String string1=string[1];
				//System.out.println(string0);
			    String[] strings=string1.split("-");
				String yearandtypes=strings[0];
			    String[] yearandtype=yearandtypes.split("_");
				String year1=yearandtype[0];
				
	            yearset.add(year1); 
	            
		    }
		    
		    HashMap<String, Vector<String>> hashmap=new HashMap<String,Vector<String>>();
		    			    
		    for(String key: arraylist.keySet()){
				String[] string=key.split("\\|");
				String string1=string[1];
				//System.out.println(string0);
			    String[] strings=string1.split("-");
				String yearandtypes=strings[0];
			    String[] yearandtype=yearandtypes.split("_");
			    String type1=yearandtype[1];
			    if(hashmap.get(type1)!=null){
	                  Vector<String> vector=new Vector<String>(); 
	                  vector=hashmap.get(type1);
	                  vector.add(string1+arraylist.get(key));
	                  hashmap.put(type1, vector);
			    }
			    else{
			    	 Vector<String> vector=new Vector<String>(); 
			    	 vector.add(string1+arraylist.get(key));
			    	 hashmap.put(type1, vector);
			    	
			    }
		    }
			    
		    

            bufferedWriter.newLine();
    	    bufferedWriter.write("PRINT BY TYPES");
		    System.out.println("PRINT BY TYPES");
		    
		    for(String type1: hashmap.keySet()){
		    	System.out.println(type1);
		    	bufferedWriter.newLine();
		    	bufferedWriter.write(type1);
			   
			    
		    	for(int i=0;i<hashmap.get(type1).size();i++){
		    	     System.out.println(hashmap.get(type1).get(i));

                     bufferedWriter.newLine();
             	     bufferedWriter.write(hashmap.get(type1).get(i));
		    	}
		 
		    }
		   
		    
		    
		    Object[] value =  yearset.toArray() ;
		    Arrays.sort(value);
		    System.out.println("");
		    System.out.println("PRINT IT BY YEARS");

            bufferedWriter.newLine();
    	    bufferedWriter.write("PRINT IT BY YEARS");
		    
		   
		   for(Object o:value){
		    	
		    for(String string:arraylist.keySet()){ 
		       
		       Iterator<String> keys = arraylist.keySet().iterator();    	
			   String[] strings=string.split("\\|");
			   String string1=strings[1];
				
	                    if(string.contains(o.toString()))
	                    {
	                    	System.out.println(string1+"  "+arraylist.get(string));

	                        bufferedWriter.newLine();
	                	    bufferedWriter.write(string1+"  "+arraylist.get(string));
	                	    
	                        while(keys.hasNext()){
	                            String i = keys.next();
	                            if(i.contains(o.toString())){
	                                keys.remove();
	                                arraylist.remove(i);
	                                break;
	                            }
	                        }
	                       
	                        break;
	                    }
		    	    
			   }
			}
		       
		}
    	
     
    	 System.out.println("");
    	 System.out.println("----------------Sentiment words by Year-----------------------------------");

         bufferedWriter.newLine();
 	    bufferedWriter.write("----------------Sentiment words by Year-----------------------------------");
 	    
    	  Object[] value3 =  sentiwordsByYear.keySet().toArray() ;
		  Arrays.sort(value3);
    	 
     for(Object year2:value3){
    	  System.out.println("");
    	  System.out.println(year2.toString()+": ");
    	  bufferedWriter.newLine();
     	  bufferedWriter.write(year2.toString()+": ");
    	  
     	  int negative = 0;
    	  int positive = 0;
    	 
    	  
    	  for(String string:sentiwordsByYear.get(year2.toString())){
    		  String[] strings=string.split("#");
    		  String word=strings[0].toLowerCase();
    		  String pos=strings[1]; 
    		  String poss=null;
		  if(pos.equals("adverb"))
			 poss="r";
		 if(pos.equals("adj"))
 		     poss="a";	 
		 if(pos.equals("noun"))
			 poss="n";
		 if(pos.equals("verb"))
			 poss="v";
		 
    		  if(sub.getPolarity(word, pos)!=null){
    		      if(sub.getPolarity(word, pos).equals("negative"))
    			        negative++;  
    		       if(sub.getPolarity(word, pos).equals("positive"))
    			        positive++;
    		  }   
    		  else{
    			  if(swn.extract(word, poss)!=null){
    		         if(swn.getNegScore(word, poss)>swn.getPosScore(word, poss))
    		        	 negative++;
    		         if(swn.getNegScore(word, poss)<swn.getPosScore(word, poss))
    		        	 positive++;
    			  }
    		  }
    		 }
    	   System.out.print("negative:"+negative+" positive:"+positive); 

        bufferedWriter.newLine();
   	    bufferedWriter.write("negative:"+negative+" positive:"+positive);
    	   	  
      }
      
     System.out.println("");
   	 System.out.println("---------------------Sentiment words by Type---------------------------------------------");	

     bufferedWriter.newLine();
	 bufferedWriter.write("---------------------Sentiment words by Type---------------------------------------------");
	    
     for(String type2:sentiwordsByType.keySet()){
    	  
    	  System.out.println("");
    	  System.out.println(type2+": ");
    	  bufferedWriter.newLine();
     	  bufferedWriter.write(type2+": ");
     	    
    	  int negative = 0;
    	  int positive = 0;
    	  
    	  for(String string:sentiwordsByType.get(type2)){
    		  String[] strings=string.split("#");
    		  String word=strings[0].toLowerCase();
    		  String pos=strings[1];
    		  String poss=null;
    		  if(pos.equals("adverb"))
    			 poss="r";
    		 if(pos.equals("adj"))
     		     poss="a";	 
    		 if(pos.equals("noun"))
				 poss="n";
    		 if(pos.equals("verb"))
				 poss="v";
    		  
    		  
    		  if(sub.getPolarity(word, pos)!=null){
    		      if(sub.getPolarity(word, pos).equals("negative"))
    			        negative++;  
    		       if(sub.getPolarity(word, pos).equals("positive"))
    			        positive++;
    		  }   
    		  else{
    			 
    			  if(swn.extract(word, poss)!=null){
    		         if(swn.getNegScore(word, poss)>swn.getPosScore(word, poss))
    		        	 negative++;
    		         if(swn.getNegScore(word, poss)<swn.getPosScore(word, poss))
    		        	 positive++;
    			  }
    		  }
    		 }
    	   System.out.print("negative:"+negative+" positive:"+positive); 
           bufferedWriter.newLine();
   	       bufferedWriter.write("negative:"+negative+" positive:"+positive);
      }
		  

		
	    
	
    long endTime = new Date().getTime(); 
	System.out.println("MINUTES IT COSTS:"+(endTime-KeywordsByNounPlus.startTime)/1000/60);
	bufferedWriter.newLine();
    bufferedWriter.write("MINUTES IT COSTS:"+(endTime-KeywordsByNounPlus.startTime)/1000/60);
    
    bufferedWriter.flush();
    bufferedWriter.close();
			
}	
		
	catch(Exception e){e.printStackTrace();}	
    } 	   
   }//process
}//class
