package fetchOpinionWords;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashMap;
import java.util.Vector;

public class SubLexicon {
	
	private String path = "resources/SubLexicon/subjclueslen1-HLTEMNLP05.txt";
	public double negative;
	public double positive;
	
	private HashMap<String, Vector<String>> _dict;

	public SubLexicon(){

		_dict = new HashMap<String, Vector<String>>();
		
		try{
			BufferedReader csv =  new BufferedReader(new FileReader(path));
			String line = "";			
			while((line = csv.readLine()) != null)
			{			
				String[] words = line.split(" ");
				
				String[] types=words[0].split("=");
				String type=types[1];
				
				String[] lens=words[1].split("=");
				String len=lens[1];
			
				String[] word1s=words[2].split("=");
				String word1=word1s[1];
			
				
				String[] pos1s=words[3].split("=");
				String pos1=pos1s[1];
				
				String[] stemmed1s=words[4].split("=");
				String stemmed1=stemmed1s[1];
				
				String[] priorpolaritys=words[5].split("=");
				String priorpolarity= priorpolaritys[1];
			
	
			    Vector<String> vector=new Vector<String>();
				vector.add(type);	
				vector.add(len);
				vector.add(stemmed1);
				vector.add(priorpolarity);
			   
				
			    _dict.put(word1+"#"+pos1, vector);
				  
	        }
		  
		}
		
		catch(Exception e){e.printStackTrace();}		
	}

	public Vector<String> extract(String word, String pos)
	{
		return _dict.get(word+"#"+pos);
	}
	

    
    public String getType(String word, String pos){
    	
    	if(_dict.get(word+"#"+pos)!=null)
     	   return _dict.get(word+"#"+pos).elementAt(0);
     	else 
     		return null;
 	    
	}
    
    public String getLen(String word, String pos){
    	
    	if(_dict.get(word+"#"+pos)!=null)
    	   return _dict.get(word+"#"+pos).elementAt(1);
    	else 
    		return null;
	    
    }

    public String getStem(String word, String pos){
    	
    	if(_dict.get(word+"#"+pos)!=null)
    	   return _dict.get(word+"#"+pos).elementAt(2);
    	else 
    		return null;
	    
    }
    
    public String getPolarity(String word, String pos){
    	
    	if(_dict.get(word+"#"+pos)!=null)
    	   return _dict.get(word+"#"+pos).elementAt(3);
    	else 
    	   return null;
	    
    }
    
	
	
	public static void main(String args[]) throws Exception { 	
		System.out.println("!!!start!!!");
		SubLexicon sub=new SubLexicon();
	    System.out.println("!!!"+sub.extract("like", "verb"));
	    System.out.println("!!!"+sub.getType("like", "verb"));
	    System.out.println("!!!"+sub.getLen("like", "verb"));
	    System.out.println("!!!"+sub.getStem("like", "verb"));
	    System.out.println("!!!"+sub.getPolarity("like", "verb"));
	}  
	
}
